
_Send_cmd:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 10
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;DFPLAYER_MINI.c,11 :: 		void Send_cmd (char cmd, char Parameter1, char Parameter2)
;DFPLAYER_MINI.c,13 :: 		unsigned int Checksum = 0;
;DFPLAYER_MINI.c,15 :: 		unsigned short i = 0;
;DFPLAYER_MINI.c,17 :: 		Checksum = Version + Cmd_Len + cmd + Feedback + Parameter1 + Parameter2;
	MOV        R16, R2
	LDI        R17, 0
	SUBI       R16, 251
	SBCI       R17, 254
	ADD        R16, R3
	LDI        R27, 0
	ADC        R17, R27
	ADD        R16, R4
	LDI        R27, 0
	ADC        R17, R27
;DFPLAYER_MINI.c,18 :: 		Checksum = 0-Checksum ;
	MOVW       R0, R16
	LDI        R16, 0
	LDI        R17, 0
	SUB        R16, R0
	SBC        R17, R1
; Checksum start address is: 18 (R18)
	MOVW       R18, R16
;DFPLAYER_MINI.c,19 :: 		CmdSequence[0] = Start_Byte;
	MOVW       R30, R28
	LDI        R27, 126
	ST         Z, R27
;DFPLAYER_MINI.c,20 :: 		CmdSequence[1] = Version;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 1
	LDI        R27, 255
	ST         Z, R27
;DFPLAYER_MINI.c,21 :: 		CmdSequence[2] = Cmd_Len;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 2
	LDI        R27, 6
	ST         Z, R27
;DFPLAYER_MINI.c,22 :: 		CmdSequence[3] = Cmd;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 3
	ST         Z, R2
;DFPLAYER_MINI.c,23 :: 		CmdSequence[4] = Feedback;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 4
	LDI        R27, 0
	ST         Z, R27
;DFPLAYER_MINI.c,24 :: 		CmdSequence[5] = Parameter1;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 5
	ST         Z, R3
;DFPLAYER_MINI.c,25 :: 		CmdSequence[6] = Parameter2;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 6
	ST         Z, R4
;DFPLAYER_MINI.c,26 :: 		CmdSequence[7] = (Checksum>>8)&0x00ff;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 7
	MOV        R16, R19
	LDI        R17, 0
	ANDI       R16, 255
	ST         Z, R16
;DFPLAYER_MINI.c,27 :: 		CmdSequence[8] = (Checksum&0x00ff);
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 8
	MOV        R16, R18
	ANDI       R16, 255
; Checksum end address is: 18 (R18)
	ST         Z, R16
;DFPLAYER_MINI.c,28 :: 		CmdSequence[9] =  End_Byte;
	MOVW       R16, R28
	MOVW       R30, R16
	ADIW       R30, 9
	LDI        R27, 239
	ST         Z, R27
;DFPLAYER_MINI.c,30 :: 		for(i=0; i<10; i++){
; i start address is: 18 (R18)
	LDI        R18, 0
; i end address is: 18 (R18)
L_Send_cmd0:
; i start address is: 18 (R18)
	CPI        R18, 10
	BRLO       L__Send_cmd22
	JMP        L_Send_cmd1
L__Send_cmd22:
;DFPLAYER_MINI.c,31 :: 		UART1_Write( CmdSequence[i]);
	MOVW       R16, R28
	MOV        R30, R18
	LDI        R31, 0
	ADD        R30, R16
	ADC        R31, R17
	LD         R16, Z
	PUSH       R2
	MOV        R2, R16
	CALL       _UART1_Write+0
	POP        R2
;DFPLAYER_MINI.c,30 :: 		for(i=0; i<10; i++){
	MOV        R16, R18
	SUBI       R16, 255
	MOV        R18, R16
;DFPLAYER_MINI.c,32 :: 		}
; i end address is: 18 (R18)
	JMP        L_Send_cmd0
L_Send_cmd1:
;DFPLAYER_MINI.c,33 :: 		}
L_end_Send_cmd:
	ADIW       R28, 9
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Send_cmd

_DF_PlayFromStart:

;DFPLAYER_MINI.c,35 :: 		void DF_PlayFromStart(void)
;DFPLAYER_MINI.c,37 :: 		Send_cmd(0x03,0x00,0x01);
	PUSH       R2
	PUSH       R3
	PUSH       R4
	LDI        R27, 1
	MOV        R4, R27
	CLR        R3
	LDI        R27, 3
	MOV        R2, R27
	CALL       _Send_cmd+0
;DFPLAYER_MINI.c,38 :: 		Delay_ms(200);
	LDI        R18, 17
	LDI        R17, 60
	LDI        R16, 204
L_DF_PlayFromStart3:
	DEC        R16
	BRNE       L_DF_PlayFromStart3
	DEC        R17
	BRNE       L_DF_PlayFromStart3
	DEC        R18
	BRNE       L_DF_PlayFromStart3
;DFPLAYER_MINI.c,39 :: 		}
L_end_DF_PlayFromStart:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _DF_PlayFromStart

_DF_Init:

;DFPLAYER_MINI.c,42 :: 		void DF_Init (char volume)
;DFPLAYER_MINI.c,44 :: 		Send_cmd(0x3F, 0x00, Source);
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R2
	LDI        R27, 2
	MOV        R4, R27
	CLR        R3
	LDI        R27, 63
	MOV        R2, R27
	CALL       _Send_cmd+0
	POP        R2
;DFPLAYER_MINI.c,45 :: 		Delay_ms(200);
	LDI        R18, 17
	LDI        R17, 60
	LDI        R16, 204
L_DF_Init5:
	DEC        R16
	BRNE       L_DF_Init5
	DEC        R17
	BRNE       L_DF_Init5
	DEC        R18
	BRNE       L_DF_Init5
;DFPLAYER_MINI.c,46 :: 		Send_cmd(0x06, 0x00, volume);
	MOV        R4, R2
	CLR        R3
	LDI        R27, 6
	MOV        R2, R27
	CALL       _Send_cmd+0
;DFPLAYER_MINI.c,47 :: 		Delay_ms(500);
	LDI        R18, 41
	LDI        R17, 150
	LDI        R16, 128
L_DF_Init7:
	DEC        R16
	BRNE       L_DF_Init7
	DEC        R17
	BRNE       L_DF_Init7
	DEC        R18
	BRNE       L_DF_Init7
;DFPLAYER_MINI.c,48 :: 		}
L_end_DF_Init:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _DF_Init

_DF_Next:

;DFPLAYER_MINI.c,51 :: 		void DF_Next (void)
;DFPLAYER_MINI.c,53 :: 		Send_cmd(next, 0x00, 0x00);
	PUSH       R2
	PUSH       R3
	PUSH       R4
	CLR        R4
	CLR        R3
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Send_cmd+0
;DFPLAYER_MINI.c,54 :: 		Delay_ms(200);
	LDI        R18, 17
	LDI        R17, 60
	LDI        R16, 204
L_DF_Next9:
	DEC        R16
	BRNE       L_DF_Next9
	DEC        R17
	BRNE       L_DF_Next9
	DEC        R18
	BRNE       L_DF_Next9
;DFPLAYER_MINI.c,55 :: 		}
L_end_DF_Next:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _DF_Next

_DF_Pause:

;DFPLAYER_MINI.c,57 :: 		void DF_Pause (void)
;DFPLAYER_MINI.c,59 :: 		Send_cmd(pause , 0, 0);
	PUSH       R2
	PUSH       R3
	PUSH       R4
	CLR        R4
	CLR        R3
	LDI        R27, 14
	MOV        R2, R27
	CALL       _Send_cmd+0
;DFPLAYER_MINI.c,60 :: 		Delay_ms(200);
	LDI        R18, 17
	LDI        R17, 60
	LDI        R16, 204
L_DF_Pause11:
	DEC        R16
	BRNE       L_DF_Pause11
	DEC        R17
	BRNE       L_DF_Pause11
	DEC        R18
	BRNE       L_DF_Pause11
;DFPLAYER_MINI.c,61 :: 		}
L_end_DF_Pause:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _DF_Pause

_DF_Previous:

;DFPLAYER_MINI.c,63 :: 		void DF_Previous (void)
;DFPLAYER_MINI.c,65 :: 		Send_cmd(previus, 0, 0);
	PUSH       R2
	PUSH       R3
	PUSH       R4
	CLR        R4
	CLR        R3
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Send_cmd+0
;DFPLAYER_MINI.c,66 :: 		Delay_ms(200);
	LDI        R18, 17
	LDI        R17, 60
	LDI        R16, 204
L_DF_Previous13:
	DEC        R16
	BRNE       L_DF_Previous13
	DEC        R17
	BRNE       L_DF_Previous13
	DEC        R18
	BRNE       L_DF_Previous13
;DFPLAYER_MINI.c,67 :: 		}
L_end_DF_Previous:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _DF_Previous

_DF_Playback:

;DFPLAYER_MINI.c,69 :: 		void DF_Playback (void)
;DFPLAYER_MINI.c,71 :: 		Send_cmd(play, 0, 0);
	PUSH       R2
	PUSH       R3
	PUSH       R4
	CLR        R4
	CLR        R3
	LDI        R27, 13
	MOV        R2, R27
	CALL       _Send_cmd+0
;DFPLAYER_MINI.c,72 :: 		Delay_ms(200);
	LDI        R18, 17
	LDI        R17, 60
	LDI        R16, 204
L_DF_Playback15:
	DEC        R16
	BRNE       L_DF_Playback15
	DEC        R17
	BRNE       L_DF_Playback15
	DEC        R18
	BRNE       L_DF_Playback15
;DFPLAYER_MINI.c,73 :: 		}
L_end_DF_Playback:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _DF_Playback

_DF_Randon:

;DFPLAYER_MINI.c,75 :: 		void DF_Randon(void)
;DFPLAYER_MINI.c,77 :: 		Send_cmd(randon , 0, 0);
	PUSH       R2
	PUSH       R3
	PUSH       R4
	CLR        R4
	CLR        R3
	LDI        R27, 24
	MOV        R2, R27
	CALL       _Send_cmd+0
;DFPLAYER_MINI.c,78 :: 		Delay_ms(200);
	LDI        R18, 17
	LDI        R17, 60
	LDI        R16, 204
L_DF_Randon17:
	DEC        R16
	BRNE       L_DF_Randon17
	DEC        R17
	BRNE       L_DF_Randon17
	DEC        R18
	BRNE       L_DF_Randon17
;DFPLAYER_MINI.c,79 :: 		}
L_end_DF_Randon:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _DF_Randon

_DF_Track:

;DFPLAYER_MINI.c,81 :: 		void DF_Track (unsigned int pista)
;DFPLAYER_MINI.c,83 :: 		Send_cmd(track, 0x00, pista);
	PUSH       R2
	PUSH       R3
	PUSH       R4
	MOVW       R16, R2
	MOV        R4, R16
	CLR        R3
	LDI        R27, 3
	MOV        R2, R27
	CALL       _Send_cmd+0
;DFPLAYER_MINI.c,84 :: 		Delay_ms(200);
	LDI        R18, 17
	LDI        R17, 60
	LDI        R16, 204
L_DF_Track19:
	DEC        R16
	BRNE       L_DF_Track19
	DEC        R17
	BRNE       L_DF_Track19
	DEC        R18
	BRNE       L_DF_Track19
;DFPLAYER_MINI.c,85 :: 		}
L_end_DF_Track:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _DF_Track

DFPLAYER_MINI____?ag:

L_end_DFPLAYER_MINI___?ag:
	RET
; end of DFPLAYER_MINI____?ag
