
_set_up:

;DFplayer.c,9 :: 		void set_up() {
;DFplayer.c,11 :: 		DDD0_bit=0;   //Rx
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	IN         R27, DDD0_bit+0
	CBR        R27, BitMask(DDD0_bit+0)
	OUT        DDD0_bit+0, R27
;DFplayer.c,12 :: 		DDD1_bit=1;   //Tx
	IN         R27, DDD1_bit+0
	SBR        R27, BitMask(DDD1_bit+0)
	OUT        DDD1_bit+0, R27
;DFplayer.c,13 :: 		DDB0_bit=1;   //DATA
	IN         R27, DDB0_bit+0
	SBR        R27, BitMask(DDB0_bit+0)
	OUT        DDB0_bit+0, R27
;DFplayer.c,14 :: 		DDB1_bit=1;   //CLK
	IN         R27, DDB1_bit+0
	SBR        R27, BitMask(DDB1_bit+0)
	OUT        DDB1_bit+0, R27
;DFplayer.c,15 :: 		DDD5_bit=0;
	IN         R27, DDD5_bit+0
	CBR        R27, BitMask(DDD5_bit+0)
	OUT        DDD5_bit+0, R27
;DFplayer.c,16 :: 		DDD6_bit=0;
	IN         R27, DDD6_bit+0
	CBR        R27, BitMask(DDD6_bit+0)
	OUT        DDD6_bit+0, R27
;DFplayer.c,17 :: 		DDD7_bit=0;
	IN         R27, DDD7_bit+0
	CBR        R27, BitMask(DDD7_bit+0)
	OUT        DDD7_bit+0, R27
;DFplayer.c,18 :: 		PORTB1_bit=0;
	IN         R27, PORTB1_bit+0
	CBR        R27, BitMask(PORTB1_bit+0)
	OUT        PORTB1_bit+0, R27
;DFplayer.c,19 :: 		PORTB0_bit=0;
	IN         R27, PORTB0_bit+0
	CBR        R27, BitMask(PORTB0_bit+0)
	OUT        PORTB0_bit+0, R27
;DFplayer.c,20 :: 		UART1_Init(9600);
	LDI        R27, 103
	STS        UBRR0L+0, R27
	LDI        R27, 0
	STS        UBRR0H+0, R27
	CALL       _UART1_Init+0
;DFplayer.c,21 :: 		Delay_ms(100);
	LDI        R18, 9
	LDI        R17, 30
	LDI        R16, 229
L_set_up0:
	DEC        R16
	BRNE       L_set_up0
	DEC        R17
	BRNE       L_set_up0
	DEC        R18
	BRNE       L_set_up0
	NOP
;DFplayer.c,22 :: 		TM1637_Init();
	CALL       _TM1637_Init+0
;DFplayer.c,23 :: 		TM1637_DisplayDecimal(trk, 0); // 0: OFF 1: ON
	CLR        R4
	CLR        R5
	LDS        R2, _trk+0
	LDS        R3, _trk+1
	CALL       _TM1637_DisplayDecimal+0
;DFplayer.c,24 :: 		DF_Init(10);
	LDI        R27, 10
	MOV        R2, R27
	CALL       _DF_Init+0
;DFplayer.c,25 :: 		DF_PlayFromStart();
	CALL       _DF_PlayFromStart+0
;DFplayer.c,26 :: 		Delay_ms(200);
	LDI        R18, 17
	LDI        R17, 60
	LDI        R16, 204
L_set_up2:
	DEC        R16
	BRNE       L_set_up2
	DEC        R17
	BRNE       L_set_up2
	DEC        R18
	BRNE       L_set_up2
;DFplayer.c,27 :: 		DF_Track (trk);
	LDS        R2, _trk+0
	LDS        R3, _trk+1
	CALL       _DF_Track+0
;DFplayer.c,28 :: 		}
L_end_set_up:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _set_up

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;DFplayer.c,30 :: 		void main() {
;DFplayer.c,31 :: 		set_up();
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	CALL       _set_up+0
;DFplayer.c,32 :: 		do {
L_main4:
;DFplayer.c,33 :: 		if ((play_pause == 1) && (aux==0)) DF_Pause(), aux=1;
	LDS        R16, _play_pause+0
	CPI        R16, 1
	BREQ       L__main50
	JMP        L__main39
L__main50:
	LDS        R16, _aux+0
	CPI        R16, 0
	BREQ       L__main51
	JMP        L__main38
L__main51:
L__main37:
	CALL       _DF_Pause+0
	LDI        R27, 1
	STS        _aux+0, R27
L__main39:
L__main38:
;DFplayer.c,34 :: 		if ((play_pause >= 2) && (aux==1)) DF_Playback(), play_pause=0, aux=0;
	LDS        R16, _play_pause+0
	CPI        R16, 2
	BRGE       L__main52
	JMP        L__main41
L__main52:
	LDS        R16, _aux+0
	CPI        R16, 1
	BREQ       L__main53
	JMP        L__main40
L__main53:
L__main36:
	CALL       _DF_Playback+0
	LDI        R27, 0
	STS        _play_pause+0, R27
	LDI        R27, 0
	STS        _aux+0, R27
L__main41:
L__main40:
;DFplayer.c,36 :: 		if (Button(&PIND,5,10,0)) e0=0;     //If the bttton is pushing.
	CLR        R6
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 5
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main54
	JMP        L_main13
L__main54:
	LDI        R27, 0
	STS        _e0+0, R27
L_main13:
;DFplayer.c,37 :: 		if (e0==0 && Button(&PIND,5,10,1)){ // If the bttton was pushing and after that is free.
	LDS        R16, _e0+0
	CPI        R16, 0
	BREQ       L__main55
	JMP        L__main43
L__main55:
	LDI        R27, 1
	MOV        R6, R27
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 5
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main56
	JMP        L__main42
L__main56:
L__main35:
;DFplayer.c,38 :: 		play_pause++;
	LDS        R16, _play_pause+0
	SUBI       R16, 255
	STS        _play_pause+0, R16
;DFplayer.c,39 :: 		Delay_ms(20);
	LDI        R18, 2
	LDI        R17, 160
	LDI        R16, 147
L_main17:
	DEC        R16
	BRNE       L_main17
	DEC        R17
	BRNE       L_main17
	DEC        R18
	BRNE       L_main17
	NOP
;DFplayer.c,40 :: 		e0=1;
	LDI        R27, 1
	STS        _e0+0, R27
;DFplayer.c,37 :: 		if (e0==0 && Button(&PIND,5,10,1)){ // If the bttton was pushing and after that is free.
L__main43:
L__main42:
;DFplayer.c,42 :: 		if (Button(&PIND,6,10,0)) e1=0;     //If the bttton is pushing.
	CLR        R6
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 6
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main57
	JMP        L_main19
L__main57:
	LDI        R27, 0
	STS        _e1+0, R27
L_main19:
;DFplayer.c,43 :: 		if (e1==0 && Button(&PIND,6,10,1)){ // If the bttton was pushing and after that is free.
	LDS        R16, _e1+0
	CPI        R16, 0
	BREQ       L__main58
	JMP        L__main45
L__main58:
	LDI        R27, 1
	MOV        R6, R27
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 6
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main59
	JMP        L__main44
L__main59:
L__main34:
;DFplayer.c,44 :: 		trk++;
	LDS        R16, _trk+0
	LDS        R17, _trk+1
	MOVW       R18, R16
	SUBI       R18, 255
	SBCI       R19, 255
	STS        _trk+0, R18
	STS        _trk+1, R19
;DFplayer.c,45 :: 		if(trk > 12)  trk = 1;    //if you want more tracks then you must change this value.
	LDI        R16, 12
	LDI        R17, 0
	CP         R16, R18
	CPC        R17, R19
	BRLO       L__main60
	JMP        L_main23
L__main60:
	LDI        R27, 1
	STS        _trk+0, R27
	LDI        R27, 0
	STS        _trk+1, R27
L_main23:
;DFplayer.c,46 :: 		TM1637_DisplayDecimal(trk, 0); // 0: OFF 1: ON
	CLR        R4
	CLR        R5
	LDS        R2, _trk+0
	LDS        R3, _trk+1
	CALL       _TM1637_DisplayDecimal+0
;DFplayer.c,47 :: 		DF_Track (trk);
	LDS        R2, _trk+0
	LDS        R3, _trk+1
	CALL       _DF_Track+0
;DFplayer.c,48 :: 		Delay_ms(20);
	LDI        R18, 2
	LDI        R17, 160
	LDI        R16, 147
L_main24:
	DEC        R16
	BRNE       L_main24
	DEC        R17
	BRNE       L_main24
	DEC        R18
	BRNE       L_main24
	NOP
;DFplayer.c,49 :: 		e1=1;
	LDI        R27, 1
	STS        _e1+0, R27
;DFplayer.c,43 :: 		if (e1==0 && Button(&PIND,6,10,1)){ // If the bttton was pushing and after that is free.
L__main45:
L__main44:
;DFplayer.c,51 :: 		if (Button(&PIND,7,10,0)) e2=0;     //If the bttton is pushing
	CLR        R6
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 7
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main61
	JMP        L_main26
L__main61:
	LDI        R27, 0
	STS        _e2+0, R27
L_main26:
;DFplayer.c,52 :: 		if (e2==0 && Button(&PIND,7,10,1)){ // If the bttton was pushing and after that is free.
	LDS        R16, _e2+0
	CPI        R16, 0
	BREQ       L__main62
	JMP        L__main47
L__main62:
	LDI        R27, 1
	MOV        R6, R27
	LDI        R27, 10
	MOV        R5, R27
	LDI        R27, 7
	MOV        R4, R27
	LDI        R27, #lo_addr(PIND+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PIND+0)
	MOV        R3, R27
	CALL       _Button+0
	TST        R16
	BRNE       L__main63
	JMP        L__main46
L__main63:
L__main33:
;DFplayer.c,53 :: 		trk--;
	LDS        R16, _trk+0
	LDS        R17, _trk+1
	SUBI       R16, 1
	SBCI       R17, 0
	STS        _trk+0, R16
	STS        _trk+1, R17
;DFplayer.c,54 :: 		if(trk < 1)  trk = 12;  //if you want more tracks then you must change this value.
	CPI        R17, 0
	BRNE       L__main64
	CPI        R16, 1
L__main64:
	BRLO       L__main65
	JMP        L_main30
L__main65:
	LDI        R27, 12
	STS        _trk+0, R27
	LDI        R27, 0
	STS        _trk+1, R27
L_main30:
;DFplayer.c,55 :: 		TM1637_DisplayDecimal(trk, 0); // 0: OFF 1: ON
	CLR        R4
	CLR        R5
	LDS        R2, _trk+0
	LDS        R3, _trk+1
	CALL       _TM1637_DisplayDecimal+0
;DFplayer.c,56 :: 		DF_Track (trk);
	LDS        R2, _trk+0
	LDS        R3, _trk+1
	CALL       _DF_Track+0
;DFplayer.c,57 :: 		Delay_ms(20);
	LDI        R18, 2
	LDI        R17, 160
	LDI        R16, 147
L_main31:
	DEC        R16
	BRNE       L_main31
	DEC        R17
	BRNE       L_main31
	DEC        R18
	BRNE       L_main31
	NOP
;DFplayer.c,58 :: 		e2=1;
	LDI        R27, 1
	STS        _e2+0, R27
;DFplayer.c,52 :: 		if (e2==0 && Button(&PIND,7,10,1)){ // If the bttton was pushing and after that is free.
L__main47:
L__main46:
;DFplayer.c,61 :: 		} while (1);
	JMP        L_main4
;DFplayer.c,62 :: 		}
L_end_main:
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
