
#include "built_in.h"
#include "tm1637_lib.h"
#include "DFPLAYER_MINI.h"

short int e0=1, e1=1, e2=1, play_pause=0, aux =0;
unsigned int trk=1;

void set_up() {

DDD0_bit=0;   //Rx
DDD1_bit=1;   //Tx
DDB0_bit=1;   //DATA
DDB1_bit=1;   //CLK
DDD5_bit=0;
DDD6_bit=0;
DDD7_bit=0;
PORTB1_bit=0;
PORTB0_bit=0;
UART1_Init(9600);
Delay_ms(100);
TM1637_Init();
TM1637_DisplayDecimal(trk, 0); // 0: OFF 1: ON
DF_Init(10);
DF_PlayFromStart();
Delay_ms(200);
DF_Track (trk);
}

void main() {
    set_up();
 do {
       if ((play_pause == 1) && (aux==0)) DF_Pause(), aux=1;
       if ((play_pause >= 2) && (aux==1)) DF_Playback(), play_pause=0, aux=0;
 
     if (Button(&PIND,5,10,0)) e0=0;     //If the bttton is pushing.
       if (e0==0 && Button(&PIND,5,10,1)){ // If the bttton was pushing and after that is free.
        play_pause++;
        Delay_ms(20);
        e0=1;
   }
     if (Button(&PIND,6,10,0)) e1=0;     //If the bttton is pushing.
       if (e1==0 && Button(&PIND,6,10,1)){ // If the bttton was pushing and after that is free.
        trk++;
        if(trk > 12)  trk = 1;    //if you want more tracks then you must change this value.
        TM1637_DisplayDecimal(trk, 0); // 0: OFF 1: ON
        DF_Track (trk);
        Delay_ms(20);
        e1=1;
   }
     if (Button(&PIND,7,10,0)) e2=0;     //If the bttton is pushing
       if (e2==0 && Button(&PIND,7,10,1)){ // If the bttton was pushing and after that is free.
        trk--;
        if(trk < 1)  trk = 12;  //if you want more tracks then you must change this value.
        TM1637_DisplayDecimal(trk, 0); // 0: OFF 1: ON
        DF_Track (trk);
        Delay_ms(20);
        e2=1;
   }
   
 } while (1);
}